﻿using MyMath;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace MyMath.Test
{


    /// <summary>
    ///This is a test class for MyMathTest and is intended
    ///to contain all MyMathTest Unit Tests
    ///</summary>
    [TestClass()]
    public class MyMathTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion



        /// <summary>
        ///A test for Add
        ///</summary>
        [TestMethod()]
        public void AddTest()
        {
            MyMath target = new MyMath();
            double a = 1;
            double b = 2;
            double expected = 3;
            double actual;
            actual = target.Add(a, b);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for Divide
        ///</summary>
        [TestMethod()]
        public void DivideTest()
        {
            MyMath target = new MyMath();
            double a = 10;
            double b = 5;
            double expected = 2;
            double actual;
            actual = target.Divide(a, b);
            Assert.AreEqual(expected, actual);

        }

        /// <summary>
        ///A test for Divide for zero
        ///</summary>
        [TestMethod(), ExpectedException(typeof(DivideByZeroException))]
        public void DivideCheckForZeroDivisor()
        {
            MyMath target = new MyMath();
            double a = 3;
            double b = 0;
            target.Divide(a, b);
        }

        /// <summary>
        ///A test for Multiply
        ///</summary>
        [TestMethod()]
        public void MultiplyTest()
        {
            MyMath target = new MyMath();
            double a = 3;
            double b = 2;
            double expected = 6;
            double actual;
            actual = target.Multiply(a, b);
            Assert.AreEqual(expected, actual);

        }

        /// <summary>
        ///A test for Subtract
        ///</summary>
        [TestMethod()]
        public void SubtractTest()
        {
            MyMath target = new MyMath();
            double a = 12;
            double b = 2;
            double expected = 10;
            double actual;
            actual = target.Subtract(a, b);
            Assert.AreEqual(expected, actual);

        }


        /// <summary>
        ///A test for MathPrivateMethod
        ///</summary>
        [TestMethod()]
        [DeploymentItem("MyMath.dll")]
        public void MathPrivateMethodTest()
        {

            MyMath_Accessor target = new MyMath_Accessor();
            double a = 30F;
            int expected = 0;
            int actual = target.MathPrivateMethod(a);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for MathPrivateMethod
        ///</summary>
        [TestMethod()]
        [DeploymentItem("MyMath.dll")]
        public void MathPrivateMethodTes2t()
        {
            MyMath_Accessor target = new MyMath_Accessor();
            double a = 2F;
            int expected = 100;
            int actual = target.MathPrivateMethod(a);
            Assert.AreEqual(expected, actual);
        }
    }
}
